package com.ibm.wsdl.extensions;

import com.ibm.wsdl.extensions.http.HTTPAddressImpl;
import com.ibm.wsdl.extensions.http.HTTPAddressSerializer;
import com.ibm.wsdl.extensions.http.HTTPBindingImpl;
import com.ibm.wsdl.extensions.http.HTTPBindingSerializer;
import com.ibm.wsdl.extensions.http.HTTPConstants;
import com.ibm.wsdl.extensions.http.HTTPOperationImpl;
import com.ibm.wsdl.extensions.http.HTTPOperationSerializer;
import com.ibm.wsdl.extensions.http.HTTPUrlEncodedImpl;
import com.ibm.wsdl.extensions.http.HTTPUrlEncodedSerializer;
import com.ibm.wsdl.extensions.http.HTTPUrlReplacementImpl;
import com.ibm.wsdl.extensions.http.HTTPUrlReplacementSerializer;
import com.ibm.wsdl.extensions.mime.MIMEConstants;
import com.ibm.wsdl.extensions.mime.MIMEContentImpl;
import com.ibm.wsdl.extensions.mime.MIMEContentSerializer;
import com.ibm.wsdl.extensions.mime.MIMEMimeXmlImpl;
import com.ibm.wsdl.extensions.mime.MIMEMimeXmlSerializer;
import com.ibm.wsdl.extensions.mime.MIMEMultipartRelatedImpl;
import com.ibm.wsdl.extensions.mime.MIMEMultipartRelatedSerializer;
import com.ibm.wsdl.extensions.mime.MIMEPartImpl;
import com.ibm.wsdl.extensions.schema.SchemaConstants;
import com.ibm.wsdl.extensions.schema.SchemaDeserializer;
import com.ibm.wsdl.extensions.schema.SchemaImpl;
import com.ibm.wsdl.extensions.schema.SchemaSerializer;
import com.ibm.wsdl.extensions.soap.SOAPAddressImpl;
import com.ibm.wsdl.extensions.soap.SOAPAddressSerializer;
import com.ibm.wsdl.extensions.soap.SOAPBindingImpl;
import com.ibm.wsdl.extensions.soap.SOAPBindingSerializer;
import com.ibm.wsdl.extensions.soap.SOAPBodyImpl;
import com.ibm.wsdl.extensions.soap.SOAPBodySerializer;
import com.ibm.wsdl.extensions.soap.SOAPConstants;
import com.ibm.wsdl.extensions.soap.SOAPFaultImpl;
import com.ibm.wsdl.extensions.soap.SOAPFaultSerializer;
import com.ibm.wsdl.extensions.soap.SOAPHeaderFaultImpl;
import com.ibm.wsdl.extensions.soap.SOAPHeaderImpl;
import com.ibm.wsdl.extensions.soap.SOAPHeaderSerializer;
import com.ibm.wsdl.extensions.soap.SOAPOperationImpl;
import com.ibm.wsdl.extensions.soap.SOAPOperationSerializer;
import javax.wsdl.Binding;
import javax.wsdl.BindingFault;
import javax.wsdl.BindingInput;
import javax.wsdl.BindingOperation;
import javax.wsdl.BindingOutput;
import javax.wsdl.Port;
import javax.wsdl.Types;
import javax.wsdl.extensions.ExtensionRegistry;
import javax.wsdl.extensions.mime.MIMEMultipartRelated;
import javax.wsdl.extensions.mime.MIMEPart;
import javax.wsdl.extensions.soap.SOAPHeader;

public class PopulatedExtensionRegistry
  extends ExtensionRegistry
{
  public static final long serialVersionUID = 1L;
  
  public PopulatedExtensionRegistry()
  {
    SOAPAddressSerializer localSOAPAddressSerializer = new SOAPAddressSerializer();
    registerSerializer(Port.class, SOAPConstants.Q_ELEM_SOAP_ADDRESS, localSOAPAddressSerializer);
    registerDeserializer(Port.class, SOAPConstants.Q_ELEM_SOAP_ADDRESS, localSOAPAddressSerializer);
    mapExtensionTypes(Port.class, SOAPConstants.Q_ELEM_SOAP_ADDRESS, SOAPAddressImpl.class);
    SOAPBindingSerializer localSOAPBindingSerializer = new SOAPBindingSerializer();
    registerSerializer(Binding.class, SOAPConstants.Q_ELEM_SOAP_BINDING, localSOAPBindingSerializer);
    registerDeserializer(Binding.class, SOAPConstants.Q_ELEM_SOAP_BINDING, localSOAPBindingSerializer);
    mapExtensionTypes(Binding.class, SOAPConstants.Q_ELEM_SOAP_BINDING, SOAPBindingImpl.class);
    SOAPHeaderSerializer localSOAPHeaderSerializer = new SOAPHeaderSerializer();
    registerSerializer(BindingInput.class, SOAPConstants.Q_ELEM_SOAP_HEADER, localSOAPHeaderSerializer);
    registerDeserializer(BindingInput.class, SOAPConstants.Q_ELEM_SOAP_HEADER, localSOAPHeaderSerializer);
    mapExtensionTypes(BindingInput.class, SOAPConstants.Q_ELEM_SOAP_HEADER, SOAPHeaderImpl.class);
    registerSerializer(BindingOutput.class, SOAPConstants.Q_ELEM_SOAP_HEADER, localSOAPHeaderSerializer);
    registerDeserializer(BindingOutput.class, SOAPConstants.Q_ELEM_SOAP_HEADER, localSOAPHeaderSerializer);
    mapExtensionTypes(BindingOutput.class, SOAPConstants.Q_ELEM_SOAP_HEADER, SOAPHeaderImpl.class);
    mapExtensionTypes(SOAPHeader.class, SOAPConstants.Q_ELEM_SOAP_HEADER_FAULT, SOAPHeaderFaultImpl.class);
    SOAPBodySerializer localSOAPBodySerializer = new SOAPBodySerializer();
    registerSerializer(BindingInput.class, SOAPConstants.Q_ELEM_SOAP_BODY, localSOAPBodySerializer);
    registerDeserializer(BindingInput.class, SOAPConstants.Q_ELEM_SOAP_BODY, localSOAPBodySerializer);
    mapExtensionTypes(BindingInput.class, SOAPConstants.Q_ELEM_SOAP_BODY, SOAPBodyImpl.class);
    registerSerializer(BindingOutput.class, SOAPConstants.Q_ELEM_SOAP_BODY, localSOAPBodySerializer);
    registerDeserializer(BindingOutput.class, SOAPConstants.Q_ELEM_SOAP_BODY, localSOAPBodySerializer);
    mapExtensionTypes(BindingOutput.class, SOAPConstants.Q_ELEM_SOAP_BODY, SOAPBodyImpl.class);
    registerSerializer(MIMEPart.class, SOAPConstants.Q_ELEM_SOAP_BODY, localSOAPBodySerializer);
    registerDeserializer(MIMEPart.class, SOAPConstants.Q_ELEM_SOAP_BODY, localSOAPBodySerializer);
    mapExtensionTypes(MIMEPart.class, SOAPConstants.Q_ELEM_SOAP_BODY, SOAPBodyImpl.class);
    SOAPFaultSerializer localSOAPFaultSerializer = new SOAPFaultSerializer();
    registerSerializer(BindingFault.class, SOAPConstants.Q_ELEM_SOAP_FAULT, localSOAPFaultSerializer);
    registerDeserializer(BindingFault.class, SOAPConstants.Q_ELEM_SOAP_FAULT, localSOAPFaultSerializer);
    mapExtensionTypes(BindingFault.class, SOAPConstants.Q_ELEM_SOAP_FAULT, SOAPFaultImpl.class);
    SOAPOperationSerializer localSOAPOperationSerializer = new SOAPOperationSerializer();
    registerSerializer(BindingOperation.class, SOAPConstants.Q_ELEM_SOAP_OPERATION, localSOAPOperationSerializer);
    registerDeserializer(BindingOperation.class, SOAPConstants.Q_ELEM_SOAP_OPERATION, localSOAPOperationSerializer);
    mapExtensionTypes(BindingOperation.class, SOAPConstants.Q_ELEM_SOAP_OPERATION, SOAPOperationImpl.class);
    HTTPAddressSerializer localHTTPAddressSerializer = new HTTPAddressSerializer();
    registerSerializer(Port.class, HTTPConstants.Q_ELEM_HTTP_ADDRESS, localHTTPAddressSerializer);
    registerDeserializer(Port.class, HTTPConstants.Q_ELEM_HTTP_ADDRESS, localHTTPAddressSerializer);
    mapExtensionTypes(Port.class, HTTPConstants.Q_ELEM_HTTP_ADDRESS, HTTPAddressImpl.class);
    HTTPOperationSerializer localHTTPOperationSerializer = new HTTPOperationSerializer();
    registerSerializer(BindingOperation.class, HTTPConstants.Q_ELEM_HTTP_OPERATION, localHTTPOperationSerializer);
    registerDeserializer(BindingOperation.class, HTTPConstants.Q_ELEM_HTTP_OPERATION, localHTTPOperationSerializer);
    mapExtensionTypes(BindingOperation.class, HTTPConstants.Q_ELEM_HTTP_OPERATION, HTTPOperationImpl.class);
    HTTPBindingSerializer localHTTPBindingSerializer = new HTTPBindingSerializer();
    registerSerializer(Binding.class, HTTPConstants.Q_ELEM_HTTP_BINDING, localHTTPBindingSerializer);
    registerDeserializer(Binding.class, HTTPConstants.Q_ELEM_HTTP_BINDING, localHTTPBindingSerializer);
    mapExtensionTypes(Binding.class, HTTPConstants.Q_ELEM_HTTP_BINDING, HTTPBindingImpl.class);
    HTTPUrlEncodedSerializer localHTTPUrlEncodedSerializer = new HTTPUrlEncodedSerializer();
    registerSerializer(BindingInput.class, HTTPConstants.Q_ELEM_HTTP_URL_ENCODED, localHTTPUrlEncodedSerializer);
    registerDeserializer(BindingInput.class, HTTPConstants.Q_ELEM_HTTP_URL_ENCODED, localHTTPUrlEncodedSerializer);
    mapExtensionTypes(BindingInput.class, HTTPConstants.Q_ELEM_HTTP_URL_ENCODED, HTTPUrlEncodedImpl.class);
    HTTPUrlReplacementSerializer localHTTPUrlReplacementSerializer = new HTTPUrlReplacementSerializer();
    registerSerializer(BindingInput.class, HTTPConstants.Q_ELEM_HTTP_URL_REPLACEMENT, localHTTPUrlReplacementSerializer);
    registerDeserializer(BindingInput.class, HTTPConstants.Q_ELEM_HTTP_URL_REPLACEMENT, localHTTPUrlReplacementSerializer);
    mapExtensionTypes(BindingInput.class, HTTPConstants.Q_ELEM_HTTP_URL_REPLACEMENT, HTTPUrlReplacementImpl.class);
    MIMEContentSerializer localMIMEContentSerializer = new MIMEContentSerializer();
    registerSerializer(BindingInput.class, MIMEConstants.Q_ELEM_MIME_CONTENT, localMIMEContentSerializer);
    registerDeserializer(BindingInput.class, MIMEConstants.Q_ELEM_MIME_CONTENT, localMIMEContentSerializer);
    mapExtensionTypes(BindingInput.class, MIMEConstants.Q_ELEM_MIME_CONTENT, MIMEContentImpl.class);
    registerSerializer(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_CONTENT, localMIMEContentSerializer);
    registerDeserializer(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_CONTENT, localMIMEContentSerializer);
    mapExtensionTypes(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_CONTENT, MIMEContentImpl.class);
    registerSerializer(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_CONTENT, localMIMEContentSerializer);
    registerDeserializer(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_CONTENT, localMIMEContentSerializer);
    mapExtensionTypes(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_CONTENT, MIMEContentImpl.class);
    MIMEMultipartRelatedSerializer localMIMEMultipartRelatedSerializer = new MIMEMultipartRelatedSerializer();
    registerSerializer(BindingInput.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, localMIMEMultipartRelatedSerializer);
    registerDeserializer(BindingInput.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, localMIMEMultipartRelatedSerializer);
    mapExtensionTypes(BindingInput.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, MIMEMultipartRelatedImpl.class);
    registerSerializer(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, localMIMEMultipartRelatedSerializer);
    registerDeserializer(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, localMIMEMultipartRelatedSerializer);
    mapExtensionTypes(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, MIMEMultipartRelatedImpl.class);
    registerSerializer(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, localMIMEMultipartRelatedSerializer);
    registerDeserializer(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, localMIMEMultipartRelatedSerializer);
    mapExtensionTypes(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_MULTIPART_RELATED, MIMEMultipartRelatedImpl.class);
    mapExtensionTypes(MIMEMultipartRelated.class, MIMEConstants.Q_ELEM_MIME_PART, MIMEPartImpl.class);
    MIMEMimeXmlSerializer localMIMEMimeXmlSerializer = new MIMEMimeXmlSerializer();
    registerSerializer(BindingInput.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, localMIMEMimeXmlSerializer);
    registerDeserializer(BindingInput.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, localMIMEMimeXmlSerializer);
    mapExtensionTypes(BindingInput.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, MIMEMimeXmlImpl.class);
    registerSerializer(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, localMIMEMimeXmlSerializer);
    registerDeserializer(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, localMIMEMimeXmlSerializer);
    mapExtensionTypes(BindingOutput.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, MIMEMimeXmlImpl.class);
    registerSerializer(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, localMIMEMimeXmlSerializer);
    registerDeserializer(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, localMIMEMimeXmlSerializer);
    mapExtensionTypes(MIMEPart.class, MIMEConstants.Q_ELEM_MIME_MIME_XML, MIMEMimeXmlImpl.class);
    mapExtensionTypes(Types.class, SchemaConstants.Q_ELEM_XSD_1999, SchemaImpl.class);
    registerDeserializer(Types.class, SchemaConstants.Q_ELEM_XSD_1999, new SchemaDeserializer());
    registerSerializer(Types.class, SchemaConstants.Q_ELEM_XSD_1999, new SchemaSerializer());
    mapExtensionTypes(Types.class, SchemaConstants.Q_ELEM_XSD_2000, SchemaImpl.class);
    registerDeserializer(Types.class, SchemaConstants.Q_ELEM_XSD_2000, new SchemaDeserializer());
    registerSerializer(Types.class, SchemaConstants.Q_ELEM_XSD_2000, new SchemaSerializer());
    mapExtensionTypes(Types.class, SchemaConstants.Q_ELEM_XSD_2001, SchemaImpl.class);
    registerDeserializer(Types.class, SchemaConstants.Q_ELEM_XSD_2001, new SchemaDeserializer());
    registerSerializer(Types.class, SchemaConstants.Q_ELEM_XSD_2001, new SchemaSerializer());
  }
}


/* Location:              /Users/anandkum/Downloads/axis-wsdl4j-1.5.1.jar!/com/ibm/wsdl/extensions/PopulatedExtensionRegistry.class
 * Java compiler version: 2 (46.0)
 * JD-Core Version:       0.7.1
 */