/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.generic.GenericDatumReader;
/*     */ import org.apache.avro.generic.GenericDatumWriter;
/*     */ import org.apache.avro.io.BinaryDecoder;
/*     */ import org.apache.avro.io.BinaryEncoder;
/*     */ import org.apache.avro.io.DecoderFactory;
/*     */ import org.apache.avro.io.EncoderFactory;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ public abstract class ByteWrappedGenericRecord<T, Y>
/*     */   extends AvroObject<Y>
/*     */ {
/*  21 */   protected BinaryDecoder decoder = null;
/*  22 */   protected BinaryEncoder encoder = null;
/*     */   
/*     */   protected GenericDatumReader<T> reader;
/*     */   protected GenericDatumWriter<T> writer;
/*  26 */   protected static EncoderFactory encoderFactory = new EncoderFactory();
/*  27 */   protected static DecoderFactory decoderFactory = new DecoderFactory();
/*     */   
/*     */ 
/*     */   public ByteWrappedGenericRecord() {}
/*     */   
/*     */ 
/*     */   public ByteWrappedGenericRecord(ARMASchema schema, Schema writerSchema, Schema readerSchema, String id)
/*     */   {
/*  35 */     super(schema, id);
/*  36 */     this.reader = new GenericDatumReader(writerSchema, readerSchema);
/*  37 */     this.writer = new GenericDatumWriter(writerSchema);
/*     */   }
/*     */   
/*     */   public ByteWrappedGenericRecord(ARMASchema schema, Schema fieldSchema, String id) {
/*  41 */     super(schema, id);
/*  42 */     this.reader = new GenericDatumReader(fieldSchema);
/*  43 */     this.writer = new GenericDatumWriter(fieldSchema);
/*     */   }
/*     */   
/*     */   protected Map<Utf8, ByteBuffer> serializeMap(Map<Utf8, T> input) throws IOException
/*     */   {
/*  48 */     Map<Utf8, ByteBuffer> output = new HashMap();
/*  49 */     ByteArrayOutputStream os = new ByteArrayOutputStream();
/*     */     try {
/*  51 */       T value = null;
/*  52 */       for (Map.Entry<Utf8, T> entry : input.entrySet()) {
/*  53 */         value = entry.getValue();
/*  54 */         if (null != value) {
/*  55 */           this.encoder = encoderFactory.binaryEncoder(os, this.encoder);
/*     */           
/*  57 */           this.writer.write(value, this.encoder);
/*  58 */           this.encoder.flush();
/*  59 */           output.put(entry.getKey(), ByteBuffer.wrap(os.toByteArray()));
/*  60 */           os.reset();
/*     */         }
/*     */       }
/*  63 */       return output;
/*     */     }
/*     */     finally {
/*  66 */       os.close();
/*     */     }
/*     */   }
/*     */   
/*     */   public byte[] serializeData(T data) throws IOException {
/*  71 */     ByteArrayOutputStream os = new ByteArrayOutputStream();
/*  72 */     EncoderFactory encoderFactory = new EncoderFactory();
/*  73 */     BinaryEncoder encoder = encoderFactory.binaryEncoder(os, null);
/*     */     try {
/*  75 */       this.writer.write(data, encoder);
/*  76 */       encoder.flush();
/*  77 */       return os.toByteArray();
/*     */     } finally {
/*  79 */       os.close();
/*     */     }
/*     */   }
/*     */   
/*     */   protected Map<Utf8, T> deSerializeMap(Map<Utf8, ByteBuffer> input, T emptyValue) throws IOException {
/*  84 */     Map<Utf8, T> output = new HashMap();
/*  85 */     if (null != input) {
/*  86 */       for (Map.Entry<Utf8, ByteBuffer> entry : input.entrySet())
/*     */       {
/*  88 */         ByteBuffer value = (ByteBuffer)entry.getValue();
/*  89 */         byte[] data = null;
/*  90 */         if ((value != null) && ((data = value.array()) != null)) {
/*  91 */           output.put(entry.getKey(), deserializeData(data));
/*     */         } else {
/*  93 */           output.put(entry.getKey(), emptyValue);
/*     */         }
/*     */       }
/*     */     }
/*  97 */     return output;
/*     */   }
/*     */   
/*     */   public T deserializeData(Schema writerSchema, Schema readerSchema, byte[] data) throws IOException {
/* 101 */     GenericDatumReader<T> reader = new GenericDatumReader(writerSchema, readerSchema);
/* 102 */     this.decoder = decoderFactory.binaryDecoder(data, this.decoder);
/* 103 */     return (T)reader.read(null, this.decoder);
/*     */   }
/*     */   
/*     */   public T deserializeData(byte[] data) throws IOException
/*     */   {
/* 108 */     this.decoder = decoderFactory.binaryDecoder(data, null);
/* 109 */     T decodedData = this.reader.read(null, this.decoder);
/* 110 */     return decodedData;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\ByteWrappedGenericRecord.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */