/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.v2.TODO;
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.core.Adapter;
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import com.sun.xml.bind.v2.runtime.Location;
/*     */ import com.sun.xml.bind.v2.runtime.SwaRefAdapter;
/*     */ import java.util.Collection;
/*     */ import javax.activation.MimeType;
/*     */ import javax.xml.bind.annotation.XmlAttachmentRef;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlElementWrapper;
/*     */ import javax.xml.bind.annotation.XmlID;
/*     */ import javax.xml.bind.annotation.XmlIDREF;
/*     */ import javax.xml.bind.annotation.XmlInlineBinaryData;
/*     */ import javax.xml.bind.annotation.XmlMimeType;
/*     */ import javax.xml.bind.annotation.XmlSchema;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapters;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ abstract class PropertyInfoImpl<T, C, F, M>
/*     */   implements PropertyInfo<T, C>, Locatable, Comparable<PropertyInfoImpl>
/*     */ {
/*     */   protected final PropertySeed<T, C, F, M> seed;
/*     */   private final boolean isCollection;
/*     */   private final ID id;
/*     */   private final MimeType expectedMimeType;
/*     */   private final boolean inlineBinary;
/*     */   private final QName schemaType;
/*     */   protected final ClassInfoImpl<T, C, F, M> parent;
/*     */   private final Adapter<T, C> adapter;
/*     */   
/*     */   protected PropertyInfoImpl(ClassInfoImpl<T, C, F, M> parent, PropertySeed<T, C, F, M> spi)
/*     */   {
/*  57 */     this.seed = spi;
/*  58 */     this.parent = parent;
/*  59 */     this.id = calcId();
/*     */     
/*  61 */     MimeType mt = Util.calcExpectedMediaType(this.seed, parent.builder);
/*  62 */     if ((mt != null) && (!kind().canHaveXmlMimeType)) {
/*  63 */       parent.builder.reportError(new IllegalAnnotationException(Messages.ILLEGAL_ANNOTATION.format(new Object[] { XmlMimeType.class.getName() }), this.seed.readAnnotation(XmlMimeType.class)));
/*     */       
/*     */ 
/*     */ 
/*  67 */       mt = null;
/*     */     }
/*  69 */     this.expectedMimeType = mt;
/*  70 */     this.inlineBinary = this.seed.hasAnnotation(XmlInlineBinaryData.class);
/*  71 */     this.schemaType = Util.calcSchemaType(reader(), this.seed, parent.clazz, getIndividualType(), this);
/*     */     
/*     */ 
/*  74 */     T t = this.seed.getRawType();
/*  75 */     this.isCollection = ((nav().isSubClassOf(t, nav().ref(Collection.class))) || (nav().isArrayButNotByteArray(t)));
/*     */     
/*     */ 
/*  78 */     XmlJavaTypeAdapter xjta = getApplicableAdapter(getIndividualType());
/*  79 */     if (xjta == null)
/*     */     {
/*  81 */       XmlAttachmentRef xsa = (XmlAttachmentRef)this.seed.readAnnotation(XmlAttachmentRef.class);
/*  82 */       if (xsa != null) {
/*  83 */         this.adapter = new Adapter(nav().asDecl(SwaRefAdapter.class), nav());
/*     */       } else {
/*  85 */         this.adapter = null;
/*     */       }
/*     */     } else {
/*  88 */       this.adapter = new Adapter(xjta, reader(), nav());
/*     */     }
/*     */   }
/*     */   
/*     */   public ClassInfoImpl<T, C, F, M> parent()
/*     */   {
/*  94 */     return this.parent;
/*     */   }
/*     */   
/*     */   protected final Navigator<T, C, F, M> nav() {
/*  98 */     return this.parent.nav();
/*     */   }
/*     */   
/* 101 */   protected final AnnotationReader<T, C, F, M> reader() { return this.parent.reader(); }
/*     */   
/*     */   public T getRawType()
/*     */   {
/* 105 */     return (T)this.seed.getRawType();
/*     */   }
/*     */   
/*     */   public T getIndividualType() {
/* 109 */     if (this.adapter != null)
/* 110 */       return (T)this.adapter.defaultType;
/* 111 */     T raw = getRawType();
/* 112 */     if (!isCollection()) {
/* 113 */       return raw;
/*     */     }
/* 115 */     if (nav().isArrayButNotByteArray(raw)) {
/* 116 */       return (T)nav().getComponentType(raw);
/*     */     }
/* 118 */     T bt = nav().getBaseClass(raw, nav().asDecl(Collection.class));
/* 119 */     if (nav().isParameterizedType(bt)) {
/* 120 */       return (T)nav().getTypeArgument(bt, 0);
/*     */     }
/* 122 */     return (T)nav().ref(Object.class);
/*     */   }
/*     */   
/*     */   public final String getName()
/*     */   {
/* 127 */     return this.seed.getName();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private boolean isApplicable(XmlJavaTypeAdapter jta, T declaredType)
/*     */   {
/* 134 */     if (jta == null) { return false;
/*     */     }
/* 136 */     T type = reader().getClassValue(jta, "type");
/* 137 */     return declaredType.equals(type);
/*     */   }
/*     */   
/*     */   private XmlJavaTypeAdapter getApplicableAdapter(T type)
/*     */   {
/* 142 */     XmlJavaTypeAdapter jta = (XmlJavaTypeAdapter)this.seed.readAnnotation(XmlJavaTypeAdapter.class);
/* 143 */     if (jta != null) {
/* 144 */       return jta;
/*     */     }
/*     */     
/* 147 */     XmlJavaTypeAdapters jtas = (XmlJavaTypeAdapters)reader().getPackageAnnotation(XmlJavaTypeAdapters.class, this.parent.clazz, this.seed);
/* 148 */     if (jtas != null) {
/* 149 */       for (XmlJavaTypeAdapter xjta : jtas.value()) {
/* 150 */         if (isApplicable(xjta, type))
/* 151 */           return xjta;
/*     */       }
/*     */     }
/* 154 */     jta = (XmlJavaTypeAdapter)reader().getPackageAnnotation(XmlJavaTypeAdapter.class, this.parent.clazz, this.seed);
/* 155 */     if (isApplicable(jta, type)) {
/* 156 */       return jta;
/*     */     }
/*     */     
/* 159 */     C refType = nav().asDecl(this.seed.getRawType());
/* 160 */     if (refType != null) {
/* 161 */       jta = (XmlJavaTypeAdapter)reader().getClassAnnotation(XmlJavaTypeAdapter.class, refType, this.seed);
/* 162 */       if (jta != null) {
/* 163 */         return jta;
/*     */       }
/*     */     }
/* 166 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Adapter<T, C> getAdapter()
/*     */   {
/* 174 */     return this.adapter;
/*     */   }
/*     */   
/*     */   public final String displayName()
/*     */   {
/* 179 */     return nav().getClassName(this.parent.getClazz()) + '#' + getName();
/*     */   }
/*     */   
/*     */   public final ID id() {
/* 183 */     return this.id;
/*     */   }
/*     */   
/*     */   private ID calcId() {
/* 187 */     if (this.seed.hasAnnotation(XmlID.class))
/*     */     {
/* 189 */       if (!this.seed.getRawType().equals(nav().ref(String.class))) {
/* 190 */         this.parent.builder.reportError(new IllegalAnnotationException(Messages.ID_MUST_BE_STRING.format(new Object[] { getName() }), this.seed));
/*     */       }
/*     */       
/* 193 */       return ID.ID;
/*     */     }
/* 195 */     if (this.seed.hasAnnotation(XmlIDREF.class)) {
/* 196 */       return ID.IDREF;
/*     */     }
/* 198 */     return ID.NONE;
/*     */   }
/*     */   
/*     */   public final MimeType getExpectedMimeType()
/*     */   {
/* 203 */     return this.expectedMimeType;
/*     */   }
/*     */   
/*     */   public final boolean inlineBinaryData() {
/* 207 */     return this.inlineBinary;
/*     */   }
/*     */   
/*     */   public final QName getSchemaType() {
/* 211 */     return this.schemaType;
/*     */   }
/*     */   
/*     */   public final boolean isCollection() {
/* 215 */     return this.isCollection;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void link()
/*     */   {
/* 224 */     if (this.id == ID.IDREF)
/*     */     {
/* 226 */       for (TypeInfo<T, C> ti : ref()) {
/* 227 */         if (!ti.canBeReferencedByIDREF()) {
/* 228 */           this.parent.builder.reportError(new IllegalAnnotationException(Messages.INVALID_IDREF.format(new Object[] { this.parent.builder.nav.getTypeName(ti.getType()) }), this));
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Locatable getUpstream()
/*     */   {
/* 240 */     return this.parent;
/*     */   }
/*     */   
/*     */   public Location getLocation() {
/* 244 */     return this.seed.getLocation();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final QName calcXmlName(XmlElement e)
/*     */   {
/* 259 */     if (e != null) {
/* 260 */       return calcXmlName(e.namespace(), e.name());
/*     */     }
/* 262 */     return calcXmlName("##default", "##default");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected final QName calcXmlName(XmlElementWrapper e)
/*     */   {
/* 269 */     if (e != null) {
/* 270 */       return calcXmlName(e.namespace(), e.name());
/*     */     }
/* 272 */     return calcXmlName("##default", "##default");
/*     */   }
/*     */   
/*     */   private QName calcXmlName(String uri, String local)
/*     */   {
/*     */     
/* 278 */     if ((local.length() == 0) || (local.equals("##default")))
/* 279 */       local = this.seed.getName();
/* 280 */     if (uri.equals("##default")) {
/* 281 */       XmlSchema xs = (XmlSchema)reader().getPackageAnnotation(XmlSchema.class, this.parent.getClazz(), this);
/*     */       
/*     */ 
/* 284 */       if (xs != null) {
/* 285 */         switch (xs.elementFormDefault()) {
/*     */         case QUALIFIED: 
/* 287 */           QName typeName = this.parent.getTypeName();
/* 288 */           if (typeName != null) {
/* 289 */             uri = typeName.getNamespaceURI();
/*     */           } else
/* 291 */             uri = xs.namespace();
/* 292 */           if (uri.length() == 0) {
/* 293 */             uri = this.parent.builder.defaultNsUri;
/*     */           }
/*     */           break;
/*     */         case UNQUALIFIED: case UNSET: 
/* 297 */           uri = "";
/*     */         }
/*     */       } else {
/* 300 */         uri = "";
/*     */       }
/*     */     }
/* 303 */     return new QName(uri.intern(), local.intern());
/*     */   }
/*     */   
/*     */   public int compareTo(PropertyInfoImpl that) {
/* 307 */     return getName().compareTo(that.getName());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\PropertyInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */