/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.FinalArrayList;
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Array;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class ValueListBeanInfoImpl
/*     */   extends JaxBeanInfo
/*     */ {
/*     */   private final Class itemType;
/*     */   private final Transducer xducer;
/*     */   
/*     */   public ValueListBeanInfoImpl(JAXBContextImpl owner, Class arrayType)
/*     */     throws JAXBException
/*     */   {
/*  31 */     super(owner, null, arrayType, false, true, false);
/*  32 */     this.itemType = this.jaxbType.getComponentType();
/*  33 */     this.xducer = owner.getBeanInfo(arrayType.getComponentType(), true).getTransducer();
/*  34 */     assert (this.xducer != null);
/*     */   }
/*     */   
/*  37 */   private final Loader loader = new Loader(true)
/*     */   {
/*     */     public void text(UnmarshallingContext.State state, CharSequence text) throws SAXException {
/*  40 */       List<Object> r = new FinalArrayList();
/*     */       
/*  42 */       int idx = 0;
/*  43 */       int len = text.length();
/*     */       for (;;)
/*     */       {
/*  46 */         int p = idx;
/*  47 */         while ((p < len) && (!WhiteSpaceProcessor.isWhiteSpace(text.charAt(p)))) {
/*  48 */           p++;
/*     */         }
/*  50 */         CharSequence token = text.subSequence(idx, p);
/*  51 */         if (!token.equals("")) {
/*     */           try {
/*  53 */             r.add(ValueListBeanInfoImpl.this.xducer.parse(token));
/*     */           } catch (AccessorException e) {
/*  55 */             handleGenericException(e, true); }
/*  56 */           continue;
/*     */         }
/*     */         
/*  59 */         if (p == len)
/*     */           break;
/*  61 */         while ((p < len) && (WhiteSpaceProcessor.isWhiteSpace(text.charAt(p))))
/*  62 */           p++;
/*  63 */         if (p == len)
/*     */           break;
/*  65 */         idx = p;
/*     */       }
/*     */       
/*  68 */       state.target = ValueListBeanInfoImpl.this.toArray(r);
/*     */     }
/*     */   };
/*     */   
/*     */   private Object toArray(List list) {
/*  73 */     int len = list.size();
/*  74 */     Object array = Array.newInstance(this.itemType, len);
/*  75 */     for (int i = 0; i < len; i++)
/*  76 */       Array.set(array, i, list.get(i));
/*  77 */     return array;
/*     */   }
/*     */   
/*     */   public void serializeBody(Object array, XMLSerializer target) throws SAXException, IOException, XMLStreamException {
/*  81 */     int len = Array.getLength(array);
/*  82 */     for (int i = 0; i < len; i++) {
/*  83 */       Object item = Array.get(array, i);
/*     */       try {
/*  85 */         this.xducer.writeText(target, item, "arrayItem");
/*     */       } catch (AccessorException e) {
/*  87 */         target.reportError("arrayItem", e);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public final void serializeURIs(Object array, XMLSerializer target) throws SAXException {
/*  93 */     if (this.xducer.useNamespace()) {
/*  94 */       int len = Array.getLength(array);
/*  95 */       for (int i = 0; i < len; i++) {
/*  96 */         Object item = Array.get(array, i);
/*     */         try {
/*  98 */           this.xducer.declareNamespace(item, target);
/*     */         } catch (AccessorException e) {
/* 100 */           target.reportError("arrayItem", e);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public final String getElementNamespaceURI(Object array) {
/* 107 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public final String getElementLocalName(Object array) {
/* 111 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public final Object createInstance(UnmarshallingContext context) {
/* 115 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public final boolean reset(Object array, UnmarshallingContext context) {
/* 119 */     return false;
/*     */   }
/*     */   
/*     */   public final String getId(Object array, XMLSerializer target) {
/* 123 */     return null;
/*     */   }
/*     */   
/*     */   public final void serializeAttributes(Object array, XMLSerializer target) {}
/*     */   
/*     */   public final void serializeRoot(Object array, XMLSerializer target)
/*     */     throws SAXException
/*     */   {
/* 131 */     target.reportError(new ValidationEventImpl(1, Messages.UNABLE_TO_MARSHAL_NON_ELEMENT.format(new Object[] { array.getClass().getName() }), null, null));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Transducer getTransducer()
/*     */   {
/* 140 */     return null;
/*     */   }
/*     */   
/*     */   public final Loader getLoader(JAXBContextImpl context, boolean typeSubstitutionCapable)
/*     */   {
/* 145 */     return this.loader;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\ValueListBeanInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */