/*     */ package com.sun.xml.bind.v2.runtime.reflect.opt;
/*     */ 
/*     */ import com.sun.xml.bind.Util;
/*     */ import com.sun.xml.bind.v2.bytecode.ClassTailor;
/*     */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeClassInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.FieldReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor.GetterSetterReflection;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Modifier;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class OptimizedTransducedAccessorFactory
/*     */ {
/*  31 */   private static final Logger logger = ;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private static final String fieldTemplateName;
/*     */   
/*     */ 
/*     */ 
/*     */   private static final String methodTemplateName;
/*     */   
/*     */ 
/*     */ 
/*     */   private static final Map<Class, String> suffixMap;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final TransducedAccessor get(RuntimePropertyInfo prop)
/*     */   {
/*  51 */     Accessor acc = prop.getAccessor();
/*     */     
/*     */ 
/*  54 */     Class opt = null;
/*     */     
/*  56 */     TypeInfo<Type, Class> parent = prop.parent();
/*  57 */     if (!(parent instanceof RuntimeClassInfo)) {
/*  58 */       return null;
/*     */     }
/*  60 */     Class dc = (Class)((RuntimeClassInfo)parent).getClazz();
/*  61 */     String newClassName = ClassTailor.toVMClassName(dc) + "_JaxbXducedAccessor_" + prop.getName();
/*     */     
/*     */ 
/*  64 */     if ((acc instanceof Accessor.FieldReflection))
/*     */     {
/*  66 */       Accessor.FieldReflection racc = (Accessor.FieldReflection)acc;
/*  67 */       Field field = racc.f;
/*     */       
/*  69 */       int mods = field.getModifiers();
/*  70 */       if ((Modifier.isPrivate(mods)) || (Modifier.isFinal(mods)))
/*     */       {
/*     */ 
/*  73 */         return null;
/*     */       }
/*  75 */       Class<?> t = field.getType();
/*  76 */       if (t.isPrimitive()) {
/*  77 */         opt = AccessorInjector.prepare(dc, fieldTemplateName + (String)suffixMap.get(t), newClassName, new String[] { ClassTailor.toVMClassName(Bean.class), ClassTailor.toVMClassName(dc), "f_" + t.getName(), field.getName() });
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  86 */     if (acc.getClass() == Accessor.GetterSetterReflection.class) {
/*  87 */       Accessor.GetterSetterReflection gacc = (Accessor.GetterSetterReflection)acc;
/*     */       
/*  89 */       if ((gacc.getter == null) || (gacc.setter == null)) {
/*  90 */         return null;
/*     */       }
/*  92 */       Class<?> t = gacc.getter.getReturnType();
/*     */       
/*  94 */       if ((Modifier.isPrivate(gacc.getter.getModifiers())) || (Modifier.isPrivate(gacc.setter.getModifiers())))
/*     */       {
/*     */ 
/*  97 */         return null;
/*     */       }
/*     */       
/* 100 */       if (t.isPrimitive()) {
/* 101 */         opt = AccessorInjector.prepare(dc, methodTemplateName + (String)suffixMap.get(t), newClassName, new String[] { ClassTailor.toVMClassName(Bean.class), ClassTailor.toVMClassName(dc), "get_" + t.getName(), gacc.getter.getName(), "set_" + t.getName(), gacc.setter.getName() });
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 112 */     if (opt == null) {
/* 113 */       return null;
/*     */     }
/* 115 */     logger.log(Level.FINE, "Using optimized TransducedAccessor for " + prop.displayName());
/*     */     
/*     */     try
/*     */     {
/* 119 */       return (TransducedAccessor)opt.newInstance();
/*     */     } catch (InstantiationException e) {
/* 121 */       logger.log(Level.INFO, "failed to load an optimized TransducedAccessor", e);
/*     */     } catch (IllegalAccessException e) {
/* 123 */       logger.log(Level.INFO, "failed to load an optimized TransducedAccessor", e);
/*     */     } catch (SecurityException e) {
/* 125 */       logger.log(Level.INFO, "failed to load an optimized TransducedAccessor", e);
/*     */     }
/* 127 */     return null;
/*     */   }
/*     */   
/*     */   static
/*     */   {
/*  37 */     String s = TransducedAccessor_field_Byte.class.getName();
/*  38 */     fieldTemplateName = s.substring(0, s.length() - "Byte".length()).replace('.', '/');
/*     */     
/*  40 */     s = TransducedAccessor_method_Byte.class.getName();
/*  41 */     methodTemplateName = s.substring(0, s.length() - "Byte".length()).replace('.', '/');
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 130 */     suffixMap = new HashMap();
/*     */     
/*     */ 
/* 133 */     suffixMap.put(Byte.TYPE, "Byte");
/* 134 */     suffixMap.put(Short.TYPE, "Short");
/* 135 */     suffixMap.put(Integer.TYPE, "Integer");
/* 136 */     suffixMap.put(Long.TYPE, "Long");
/* 137 */     suffixMap.put(Boolean.TYPE, "Boolean");
/* 138 */     suffixMap.put(Float.TYPE, "Float");
/* 139 */     suffixMap.put(Double.TYPE, "Double");
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\opt\OptimizedTransducedAccessorFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */