/*     */ package net.rubyeye.xmemcached.command;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import com.google.code.yanf4j.core.WriteMessage;
/*     */ import com.google.code.yanf4j.core.impl.FutureImpl;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedClientException;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedDecodeException;
/*     */ import net.rubyeye.xmemcached.exception.MemcachedServerException;
/*     */ import net.rubyeye.xmemcached.exception.UnknownCommandException;
/*     */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*     */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Command
/*     */   implements WriteMessage
/*     */ {
/*     */   public static final byte REQUEST_MAGIC_NUMBER = -128;
/*     */   public static final byte RESPONSE_MAGIC_NUMBER = -127;
/*     */   protected String key;
/*     */   protected byte[] keyBytes;
/*     */   protected volatile Object result;
/*     */   protected CountDownLatch latch;
/*     */   protected CommandType commandType;
/*     */   protected Exception exception;
/*     */   protected volatile IoBuffer ioBuffer;
/*     */   protected volatile boolean cancel;
/*     */   protected volatile OperationStatus status;
/*     */   
/*     */   public final Object getMessage()
/*     */   {
/*  44 */     return this;
/*     */   }
/*     */   
/*     */   public final synchronized IoBuffer getWriteBuffer() {
/*  48 */     return getIoBuffer();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  64 */   protected int mergeCount = -1;
/*     */   protected Transcoder transcoder;
/*     */   protected boolean noreply;
/*     */   protected FutureImpl<Boolean> writeFuture;
/*     */   
/*     */   public void setWriteBuffer(IoBuffer buffers) {}
/*     */   
/*  71 */   public final byte[] getKeyBytes() { return this.keyBytes; }
/*     */   
/*     */   public final void setKeyBytes(byte[] keyBytes)
/*     */   {
/*  75 */     this.keyBytes = keyBytes;
/*     */   }
/*     */   
/*     */   public void setCommandType(CommandType commandType) {
/*  79 */     this.commandType = commandType;
/*     */   }
/*     */   
/*     */   public int getMergeCount() {
/*  83 */     return this.mergeCount;
/*     */   }
/*     */   
/*     */   public Transcoder getTranscoder()
/*     */   {
/*  88 */     return this.transcoder;
/*     */   }
/*     */   
/*     */   public void setTranscoder(Transcoder transcoder)
/*     */   {
/*  93 */     this.transcoder = transcoder;
/*     */   }
/*     */   
/*     */   public void setMergeCount(int mergetCount) {
/*  97 */     this.mergeCount = mergetCount;
/*     */   }
/*     */   
/*     */   public Command()
/*     */   {
/* 102 */     this.status = OperationStatus.SENDING;
/*     */   }
/*     */   
/*     */   public Command(String key, byte[] keyBytes, CountDownLatch latch)
/*     */   {
/* 107 */     this.key = key;
/* 108 */     this.keyBytes = keyBytes;
/* 109 */     this.status = OperationStatus.SENDING;
/* 110 */     this.latch = latch;
/*     */   }
/*     */   
/*     */ 
/*     */   public Command(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch)
/*     */   {
/* 116 */     this.key = key;
/* 117 */     this.keyBytes = keyBytes;
/* 118 */     this.status = OperationStatus.SENDING;
/* 119 */     this.latch = latch;
/* 120 */     this.commandType = cmdType;
/*     */   }
/*     */   
/*     */   public Command(CommandType cmdType) {
/* 124 */     this.commandType = cmdType;
/* 125 */     this.status = OperationStatus.SENDING;
/*     */   }
/*     */   
/*     */   public Command(CommandType cmdType, CountDownLatch latch) {
/* 129 */     this.commandType = cmdType;
/* 130 */     this.latch = latch;
/* 131 */     this.status = OperationStatus.SENDING;
/*     */   }
/*     */   
/*     */ 
/*     */   public Command(String key, CommandType commandType, CountDownLatch latch)
/*     */   {
/* 137 */     this.key = key;
/* 138 */     this.commandType = commandType;
/* 139 */     this.latch = latch;
/* 140 */     this.status = OperationStatus.SENDING;
/*     */   }
/*     */   
/*     */   public OperationStatus getStatus() {
/* 144 */     return this.status;
/*     */   }
/*     */   
/*     */   public final void setStatus(OperationStatus status) {
/* 148 */     this.status = status;
/*     */   }
/*     */   
/*     */   public final void setIoBuffer(IoBuffer ioBuffer) {
/* 152 */     this.ioBuffer = ioBuffer;
/*     */   }
/*     */   
/*     */   public Exception getException() {
/* 156 */     return this.exception;
/*     */   }
/*     */   
/*     */   public void setException(Exception throwable) {
/* 160 */     this.exception = throwable;
/*     */   }
/*     */   
/*     */   public final String getKey() {
/* 164 */     return this.key;
/*     */   }
/*     */   
/*     */   public final void setKey(String key) {
/* 168 */     this.key = key;
/*     */   }
/*     */   
/*     */   public final Object getResult() {
/* 172 */     return this.result;
/*     */   }
/*     */   
/*     */   public final void setResult(Object result) {
/* 176 */     this.result = result;
/*     */   }
/*     */   
/*     */   public final IoBuffer getIoBuffer() {
/* 180 */     return this.ioBuffer;
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/*     */     try {
/* 186 */       return new String(this.ioBuffer.buf().array(), "utf-8");
/*     */     }
/*     */     catch (UnsupportedEncodingException e) {}
/* 189 */     return "[error]";
/*     */   }
/*     */   
/*     */   public boolean isCancel() {
/* 193 */     return (this.status == OperationStatus.SENDING) && (this.cancel);
/*     */   }
/*     */   
/*     */   public final void cancel() {
/* 197 */     this.cancel = true;
/* 198 */     if (this.ioBuffer != null) {
/* 199 */       this.ioBuffer.free();
/*     */     }
/*     */   }
/*     */   
/*     */   public final CountDownLatch getLatch() {
/* 204 */     return this.latch;
/*     */   }
/*     */   
/*     */   public final void countDownLatch() {
/* 208 */     if (this.latch != null) {
/* 209 */       this.latch.countDown();
/* 210 */       if (this.latch.getCount() == 0L) {
/* 211 */         this.status = OperationStatus.DONE;
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public final CommandType getCommandType() {
/* 217 */     return this.commandType;
/*     */   }
/*     */   
/*     */   public final void setLatch(CountDownLatch latch) {
/* 221 */     this.latch = latch;
/*     */   }
/*     */   
/*     */   public abstract void encode();
/*     */   
/*     */   public abstract boolean decode(MemcachedTCPSession paramMemcachedTCPSession, ByteBuffer paramByteBuffer);
/*     */   
/*     */   protected final void decodeError(String msg, Throwable e)
/*     */   {
/* 230 */     throw new MemcachedDecodeException(msg == null ? "decode error,session will be closed,key=" + this.key : msg, e);
/*     */   }
/*     */   
/*     */   protected final void decodeError()
/*     */   {
/* 235 */     throw new MemcachedDecodeException("decode error,session will be closed,key=" + this.key);
/*     */   }
/*     */   
/*     */   protected final boolean decodeError(String line)
/*     */   {
/* 240 */     if (line.startsWith("ERROR")) {
/* 241 */       String[] splits = line.split("ERROR");
/* 242 */       String errorMsg = "Unknow command " + getCommandType();
/*     */       
/* 244 */       setException(new UnknownCommandException("Response error,error message:" + errorMsg + ",key=" + this.key));
/*     */       
/* 246 */       countDownLatch();
/* 247 */       return true; }
/* 248 */     if (line.startsWith("CLIENT_ERROR")) {
/* 249 */       setException(new MemcachedClientException(getErrorMsg(line, "Unknown Client Error")));
/*     */       
/* 251 */       countDownLatch();
/* 252 */       return true; }
/* 253 */     if (line.startsWith("SERVER_ERROR")) {
/* 254 */       setException(new MemcachedServerException(getErrorMsg(line, "Unknown Server Error")));
/*     */       
/* 256 */       countDownLatch();
/* 257 */       return true;
/*     */     }
/* 259 */     throw new MemcachedDecodeException("Decode error,session will be closed,key=" + this.key + ",server returns=" + line);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected final boolean decodeError(Session session, ByteBuffer buffer)
/*     */   {
/* 266 */     String line = ByteUtils.nextLine(buffer);
/* 267 */     if (line == null) {
/* 268 */       return false;
/*     */     }
/* 270 */     return decodeError(line);
/*     */   }
/*     */   
/*     */   private String getErrorMsg(String line, String defaultMsg)
/*     */   {
/* 275 */     int index = line.indexOf(" ");
/* 276 */     String errorMsg = index > 0 ? line.substring(index + 1) : defaultMsg;
/* 277 */     errorMsg = errorMsg + ",key=" + this.key;
/* 278 */     return errorMsg;
/*     */   }
/*     */   
/*     */   public final boolean isNoreply() {
/* 282 */     return this.noreply;
/*     */   }
/*     */   
/*     */   public final void setNoreply(boolean noreply) {
/* 286 */     this.noreply = noreply;
/*     */   }
/*     */   
/*     */   public FutureImpl<Boolean> getWriteFuture() {
/* 290 */     return this.writeFuture;
/*     */   }
/*     */   
/*     */   public final void setWriteFuture(FutureImpl<Boolean> writeFuture) {
/* 294 */     this.writeFuture = writeFuture;
/*     */   }
/*     */   
/*     */   public final boolean isWriting() {
/* 298 */     return true;
/*     */   }
/*     */   
/*     */   public final void writing() {}
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\Command.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */