/*     */ package org.codehaus.jackson.map;
/*     */ 
/*     */ import java.text.DateFormat;
/*     */ import java.util.HashMap;
/*     */ import org.codehaus.jackson.Base64Variant;
/*     */ import org.codehaus.jackson.Base64Variants;
/*     */ import org.codehaus.jackson.map.introspect.Annotated;
/*     */ import org.codehaus.jackson.map.introspect.AnnotatedClass;
/*     */ import org.codehaus.jackson.map.introspect.NopAnnotationIntrospector;
/*     */ import org.codehaus.jackson.map.introspect.VisibilityChecker;
/*     */ import org.codehaus.jackson.map.jsontype.SubtypeResolver;
/*     */ import org.codehaus.jackson.map.jsontype.TypeResolverBuilder;
/*     */ import org.codehaus.jackson.map.type.ClassKey;
/*     */ import org.codehaus.jackson.map.type.TypeFactory;
/*     */ import org.codehaus.jackson.map.util.ClassUtil;
/*     */ import org.codehaus.jackson.map.util.LinkedNode;
/*     */ import org.codehaus.jackson.node.JsonNodeFactory;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DeserializationConfig
/*     */   extends MapperConfig<DeserializationConfig>
/*     */ {
/*     */   public static enum Feature
/*     */   {
/*  58 */     USE_ANNOTATIONS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  74 */     AUTO_DETECT_SETTERS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  90 */     AUTO_DETECT_CREATORS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 107 */     AUTO_DETECT_FIELDS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 125 */     USE_GETTERS_AS_SETTERS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 135 */     CAN_OVERRIDE_ACCESS_MODIFIERS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 157 */     USE_BIG_DECIMAL_FOR_FLOATS(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 175 */     USE_BIG_INTEGER_FOR_INTS(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 191 */     READ_ENUMS_USING_TO_STRING(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 216 */     FAIL_ON_UNKNOWN_PROPERTIES(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 231 */     FAIL_ON_NULL_FOR_PRIMITIVES(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 249 */     FAIL_ON_NUMBERS_FOR_ENUMS(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 269 */     WRAP_EXCEPTIONS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 287 */     WRAP_ROOT_VALUE(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 301 */     ACCEPT_EMPTY_STRING_AS_NULL_OBJECT(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 314 */     ACCEPT_SINGLE_VALUE_AS_ARRAY(false);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     final boolean _defaultState;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public static int collectDefaults()
/*     */     {
/* 332 */       int flags = 0;
/* 333 */       for (Feature f : values()) {
/* 334 */         if (f.enabledByDefault()) {
/* 335 */           flags |= f.getMask();
/*     */         }
/*     */       }
/* 338 */       return flags;
/*     */     }
/*     */     
/*     */     private Feature(boolean defaultState) {
/* 342 */       this._defaultState = defaultState;
/*     */     }
/*     */     
/* 345 */     public boolean enabledByDefault() { return this._defaultState; }
/*     */     
/* 347 */     public int getMask() { return 1 << ordinal(); }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 354 */   protected static final int DEFAULT_FEATURE_FLAGS = ;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 365 */   protected int _featureFlags = DEFAULT_FEATURE_FLAGS;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected LinkedNode<DeserializationProblemHandler> _problemHandlers;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected AbstractTypeResolver _abstractTypeResolver;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected JsonNodeFactory _nodeFactory;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public DeserializationConfig(ClassIntrospector<? extends BeanDescription> intr, AnnotationIntrospector annIntr, VisibilityChecker<?> vc, SubtypeResolver subtypeResolver, PropertyNamingStrategy propertyNamingStrategy, TypeFactory typeFactory, HandlerInstantiator handlerInstantiator)
/*     */   {
/* 407 */     super(intr, annIntr, vc, subtypeResolver, propertyNamingStrategy, typeFactory, handlerInstantiator);
/* 408 */     this._nodeFactory = JsonNodeFactory.instance;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected DeserializationConfig(DeserializationConfig src)
/*     */   {
/* 415 */     this(src, src._base);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private DeserializationConfig(DeserializationConfig src, HashMap<ClassKey, Class<?>> mixins, SubtypeResolver str)
/*     */   {
/* 427 */     this(src, src._base);
/* 428 */     this._mixInAnnotations = mixins;
/* 429 */     this._subtypeResolver = str;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected DeserializationConfig(DeserializationConfig src, MapperConfig.Base base)
/*     */   {
/* 437 */     super(src, base, src._subtypeResolver);
/* 438 */     this._featureFlags = src._featureFlags;
/* 439 */     this._abstractTypeResolver = src._abstractTypeResolver;
/* 440 */     this._problemHandlers = src._problemHandlers;
/* 441 */     this._nodeFactory = src._nodeFactory;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected DeserializationConfig(DeserializationConfig src, JsonNodeFactory f)
/*     */   {
/* 449 */     super(src);
/* 450 */     this._featureFlags = src._featureFlags;
/* 451 */     this._abstractTypeResolver = src._abstractTypeResolver;
/* 452 */     this._problemHandlers = src._problemHandlers;
/* 453 */     this._nodeFactory = f;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public DeserializationConfig withClassIntrospector(ClassIntrospector<? extends BeanDescription> ci)
/*     */   {
/* 464 */     return new DeserializationConfig(this, this._base.withClassIntrospector(ci));
/*     */   }
/*     */   
/*     */   public DeserializationConfig withAnnotationIntrospector(AnnotationIntrospector ai)
/*     */   {
/* 469 */     return new DeserializationConfig(this, this._base.withAnnotationIntrospector(ai));
/*     */   }
/*     */   
/*     */   public DeserializationConfig withVisibilityChecker(VisibilityChecker<?> vc)
/*     */   {
/* 474 */     return new DeserializationConfig(this, this._base.withVisibilityChecker(vc));
/*     */   }
/*     */   
/*     */   public DeserializationConfig withTypeResolverBuilder(TypeResolverBuilder<?> trb)
/*     */   {
/* 479 */     return new DeserializationConfig(this, this._base.withTypeResolverBuilder(trb));
/*     */   }
/*     */   
/*     */ 
/*     */   public DeserializationConfig withSubtypeResolver(SubtypeResolver str)
/*     */   {
/* 485 */     DeserializationConfig cfg = new DeserializationConfig(this);
/* 486 */     cfg._subtypeResolver = str;
/* 487 */     return cfg;
/*     */   }
/*     */   
/*     */   public DeserializationConfig withPropertyNamingStrategy(PropertyNamingStrategy pns)
/*     */   {
/* 492 */     return new DeserializationConfig(this, this._base.withPropertyNamingStrategy(pns));
/*     */   }
/*     */   
/*     */   public DeserializationConfig withTypeFactory(TypeFactory tf)
/*     */   {
/* 497 */     return tf == this._base.getTypeFactory() ? this : new DeserializationConfig(this, this._base.withTypeFactory(tf));
/*     */   }
/*     */   
/*     */   public DeserializationConfig withDateFormat(DateFormat df)
/*     */   {
/* 502 */     return df == this._base.getDateFormat() ? this : new DeserializationConfig(this, this._base.withDateFormat(df));
/*     */   }
/*     */   
/*     */   public DeserializationConfig withHandlerInstantiator(HandlerInstantiator hi)
/*     */   {
/* 507 */     return hi == this._base.getHandlerInstantiator() ? this : new DeserializationConfig(this, this._base.withHandlerInstantiator(hi));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public DeserializationConfig withNodeFactory(JsonNodeFactory f)
/*     */   {
/* 520 */     return new DeserializationConfig(this, f);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void enable(Feature f)
/*     */   {
/* 533 */     this._featureFlags |= f.getMask();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void disable(Feature f)
/*     */   {
/* 540 */     this._featureFlags &= (f.getMask() ^ 0xFFFFFFFF);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void set(Feature f, boolean state)
/*     */   {
/* 548 */     if (state) {
/* 549 */       enable(f);
/*     */     } else {
/* 551 */       disable(f);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final boolean isEnabled(Feature f)
/*     */   {
/* 559 */     return (this._featureFlags & f.getMask()) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void fromAnnotations(Class<?> cls)
/*     */   {
/* 600 */     AnnotationIntrospector ai = getAnnotationIntrospector();
/* 601 */     AnnotatedClass ac = AnnotatedClass.construct(cls, ai, null);
/*     */     
/* 603 */     VisibilityChecker<?> prevVc = getDefaultVisibilityChecker();
/* 604 */     this._base = this._base.withVisibilityChecker(ai.findAutoDetectVisibility(ac, prevVc));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public DeserializationConfig createUnshared(SubtypeResolver subtypeResolver)
/*     */   {
/* 618 */     HashMap<ClassKey, Class<?>> mixins = this._mixInAnnotations;
/*     */     
/* 620 */     this._mixInAnnotationsShared = true;
/* 621 */     return new DeserializationConfig(this, mixins, subtypeResolver);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public AnnotationIntrospector getAnnotationIntrospector()
/*     */   {
/* 634 */     if (isEnabled(Feature.USE_ANNOTATIONS)) {
/* 635 */       return super.getAnnotationIntrospector();
/*     */     }
/* 637 */     return NopAnnotationIntrospector.instance;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspectClassAnnotations(Class<?> cls)
/*     */   {
/* 649 */     return getClassIntrospector().forClassAnnotations(this, cls, this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspectDirectClassAnnotations(Class<?> cls)
/*     */   {
/* 662 */     return getClassIntrospector().forDirectClassAnnotations(this, cls, this);
/*     */   }
/*     */   
/*     */   public boolean isAnnotationProcessingEnabled()
/*     */   {
/* 667 */     return isEnabled(Feature.USE_ANNOTATIONS);
/*     */   }
/*     */   
/*     */   public boolean canOverrideAccessModifiers()
/*     */   {
/* 672 */     return isEnabled(Feature.CAN_OVERRIDE_ACCESS_MODIFIERS);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public LinkedNode<DeserializationProblemHandler> getProblemHandlers()
/*     */   {
/* 687 */     return this._problemHandlers;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addHandler(DeserializationProblemHandler h)
/*     */   {
/* 699 */     if (!LinkedNode.contains(this._problemHandlers, h)) {
/* 700 */       this._problemHandlers = new LinkedNode(h, this._problemHandlers);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void clearHandlers()
/*     */   {
/* 712 */     this._problemHandlers = null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Base64Variant getBase64Variant()
/*     */   {
/* 728 */     return Base64Variants.getDefaultVariant();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final JsonNodeFactory getNodeFactory()
/*     */   {
/* 735 */     return this._nodeFactory;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspect(JavaType type)
/*     */   {
/* 752 */     return getClassIntrospector().forDeserialization(this, type, this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspectForCreation(JavaType type)
/*     */   {
/* 761 */     return getClassIntrospector().forCreation(this, type, this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JsonDeserializer<Object> deserializerInstance(Annotated annotated, Class<? extends JsonDeserializer<?>> deserClass)
/*     */   {
/* 774 */     HandlerInstantiator hi = getHandlerInstantiator();
/* 775 */     if (hi != null) {
/* 776 */       JsonDeserializer<?> deser = hi.deserializerInstance(this, annotated, deserClass);
/* 777 */       if (deser != null) {
/* 778 */         return deser;
/*     */       }
/*     */     }
/* 781 */     return (JsonDeserializer)ClassUtil.createInstance(deserClass, canOverrideAccessModifiers());
/*     */   }
/*     */   
/*     */ 
/*     */   public KeyDeserializer keyDeserializerInstance(Annotated annotated, Class<? extends KeyDeserializer> keyDeserClass)
/*     */   {
/* 787 */     HandlerInstantiator hi = getHandlerInstantiator();
/* 788 */     if (hi != null) {
/* 789 */       KeyDeserializer keyDeser = hi.keyDeserializerInstance(this, annotated, keyDeserClass);
/* 790 */       if (keyDeser != null) {
/* 791 */         return keyDeser;
/*     */       }
/*     */     }
/* 794 */     return (KeyDeserializer)ClassUtil.createInstance(keyDeserClass, canOverrideAccessModifiers());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public DeserializationConfig createUnshared(TypeResolverBuilder<?> typer, VisibilityChecker<?> vc, SubtypeResolver str)
/*     */   {
/* 811 */     return createUnshared(str).withTypeResolverBuilder(typer).withVisibilityChecker(vc);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public void setNodeFactory(JsonNodeFactory nf)
/*     */   {
/* 823 */     this._nodeFactory = nf;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public AbstractTypeResolver getAbstractTypeResolver()
/*     */   {
/* 839 */     return this._abstractTypeResolver;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public void setAbstractTypeResolver(AbstractTypeResolver atr)
/*     */   {
/* 853 */     this._abstractTypeResolver = atr;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\DeserializationConfig.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */