/*     */ package org.codehaus.jackson.map.jsontype.impl;
/*     */ 
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import org.codehaus.jackson.annotate.JsonTypeInfo.Id;
/*     */ import org.codehaus.jackson.map.AnnotationIntrospector;
/*     */ import org.codehaus.jackson.map.MapperConfig;
/*     */ import org.codehaus.jackson.map.introspect.BasicBeanDescription;
/*     */ import org.codehaus.jackson.map.jsontype.NamedType;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TypeNameIdResolver
/*     */   extends TypeIdResolverBase
/*     */ {
/*     */   protected final MapperConfig<?> _config;
/*     */   protected final HashMap<String, String> _typeToId;
/*     */   protected final HashMap<String, JavaType> _idToType;
/*     */   
/*     */   protected TypeNameIdResolver(MapperConfig<?> config, JavaType baseType, HashMap<String, String> typeToId, HashMap<String, JavaType> idToType)
/*     */   {
/*  32 */     super(baseType, config.getTypeFactory());
/*  33 */     this._config = config;
/*  34 */     this._typeToId = typeToId;
/*  35 */     this._idToType = idToType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static TypeNameIdResolver construct(MapperConfig<?> config, JavaType baseType, Collection<NamedType> subtypes, boolean forSer, boolean forDeser)
/*     */   {
/*  43 */     if (forSer == forDeser) throw new IllegalArgumentException();
/*  44 */     HashMap<String, String> typeToId = null;
/*  45 */     HashMap<String, JavaType> idToType = null;
/*     */     
/*  47 */     if (forSer) {
/*  48 */       typeToId = new HashMap();
/*     */     }
/*  50 */     if (forDeser) {
/*  51 */       idToType = new HashMap();
/*     */     }
/*  53 */     if (subtypes != null) {
/*  54 */       for (NamedType t : subtypes)
/*     */       {
/*     */ 
/*     */ 
/*  58 */         Class<?> cls = t.getType();
/*  59 */         String id = t.hasName() ? t.getName() : _defaultTypeId(cls);
/*  60 */         if (forSer) {
/*  61 */           typeToId.put(cls.getName(), id);
/*     */         }
/*  63 */         if (forDeser)
/*     */         {
/*     */ 
/*     */ 
/*     */ 
/*  68 */           JavaType prev = (JavaType)idToType.get(id);
/*  69 */           if ((prev == null) || 
/*  70 */             (!cls.isAssignableFrom(prev.getRawClass())))
/*     */           {
/*     */ 
/*     */ 
/*  74 */             idToType.put(id, config.constructType(cls)); }
/*     */         }
/*     */       }
/*     */     }
/*  78 */     return new TypeNameIdResolver(config, baseType, typeToId, idToType);
/*     */   }
/*     */   
/*  81 */   public JsonTypeInfo.Id getMechanism() { return JsonTypeInfo.Id.NAME; }
/*     */   
/*     */ 
/*     */   public String idFromValue(Object value)
/*     */   {
/*  86 */     Class<?> cls = value.getClass();
/*  87 */     String key = cls.getName();
/*     */     String name;
/*  89 */     synchronized (this._typeToId) {
/*  90 */       name = (String)this._typeToId.get(key);
/*  91 */       if (name == null)
/*     */       {
/*     */ 
/*  94 */         if (this._config.isAnnotationProcessingEnabled()) {
/*  95 */           BasicBeanDescription beanDesc = (BasicBeanDescription)this._config.introspectClassAnnotations(cls);
/*  96 */           name = this._config.getAnnotationIntrospector().findTypeName(beanDesc.getClassInfo());
/*     */         }
/*  98 */         if (name == null)
/*     */         {
/* 100 */           name = _defaultTypeId(cls);
/*     */         }
/* 102 */         this._typeToId.put(key, name);
/*     */       }
/*     */     }
/* 105 */     return name;
/*     */   }
/*     */   
/*     */ 
/*     */   public String idFromValueAndType(Object value, Class<?> type)
/*     */   {
/* 111 */     return idFromValue(value);
/*     */   }
/*     */   
/*     */   public JavaType typeFromId(String id)
/*     */     throws IllegalArgumentException
/*     */   {
/* 117 */     JavaType t = (JavaType)this._idToType.get(id);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 123 */     return t;
/*     */   }
/*     */   
/*     */ 
/*     */   public String toString()
/*     */   {
/* 129 */     StringBuilder sb = new StringBuilder();
/* 130 */     sb.append('[').append(getClass().getName());
/* 131 */     sb.append("; id-to-type=").append(this._idToType);
/* 132 */     sb.append(']');
/* 133 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected static String _defaultTypeId(Class<?> cls)
/*     */   {
/* 148 */     String n = cls.getName();
/* 149 */     int ix = n.lastIndexOf('.');
/* 150 */     return ix < 0 ? n : n.substring(ix + 1);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\jsontype\impl\TypeNameIdResolver.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */