/*    */ package com.netapp.asup.data.pojo;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.pojo.ARMAPojoBuilder;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import org.xml.sax.Attributes;
/*    */ import org.xml.sax.helpers.DefaultHandler;
/*    */ 
/*    */ 
/*    */ public class POJORegistryHandler
/*    */   extends DefaultHandler
/*    */ {
/* 14 */   private static final AsupLogger LOG = AsupLogger.getLogger(POJORegistryHandler.class);
/*    */   Map<String, Map<String, ARMAPojoBuilder>> packageToBuilder;
/*    */   private static final String POJOS = "pojos";
/*    */   private static final String POJO = "pojo";
/*    */   
/*    */   public Map<String, Map<String, ARMAPojoBuilder>> getPackageToBuilder() {
/* 20 */     return this.packageToBuilder;
/*    */   }
/*    */   
/*    */   private String packageName;
/*    */   private String objectName;
/*    */   private String builderClass;
/*    */   public void startDocument()
/*    */   {
/* 28 */     this.packageToBuilder = new HashMap();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public void endDocument() {}
/*    */   
/*    */ 
/*    */ 
/*    */   public void startElement(String uri, String localName, String qName, Attributes attributes)
/*    */   {
/* 39 */     if (qName.equals("pojos")) {
/* 40 */       this.packageName = attributes.getValue("packagename");
/*    */     }
/*    */     
/* 43 */     if (qName.equals("pojo")) {
/* 44 */       this.objectName = attributes.getValue("objectname");
/* 45 */       this.builderClass = attributes.getValue("builderclass");
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public void endElement(String uri, String localName, String qName)
/*    */   {
/* 53 */     if (qName.equals("pojo")) {
/* 54 */       Map<String, ARMAPojoBuilder> builderMap = (Map)this.packageToBuilder.get(this.packageName);
/* 55 */       if (builderMap == null) builderMap = new HashMap();
/*    */       try {
/* 57 */         ARMAPojoBuilder pojoBuilder = (ARMAPojoBuilder)Class.forName(this.builderClass).newInstance();
/* 58 */         builderMap.put(this.objectName, pojoBuilder);
/* 59 */         this.packageToBuilder.put(this.packageName, builderMap);
/*    */       }
/*    */       catch (InstantiationException e) {
/* 62 */         LOG.warn(null, "failed to instantiate " + this.builderClass + " message : " + e.getMessage());
/*    */       } catch (IllegalAccessException e) {
/* 64 */         LOG.warn(null, " access exception while trying to instantiate class " + this.builderClass + " message :" + e.getMessage());
/*    */       }
/*    */       catch (ClassNotFoundException e)
/*    */       {
/* 68 */         LOG.warn(null, "Class not found in the classpath while instantiating class : " + this.builderClass + " message : " + e.getMessage());
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */   public void characters(char[] ch, int start, int length) {}
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\pojo\POJORegistryHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */