/*    */ package com.sun.xml.bind.v2.model.impl;
/*    */ 
/*    */ import com.sun.xml.bind.api.impl.NameConverter;
/*    */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*    */ import com.sun.xml.bind.v2.model.core.AttributePropertyInfo;
/*    */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*    */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*    */ import javax.xml.bind.annotation.XmlAttribute;
/*    */ import javax.xml.bind.annotation.XmlSchema;
/*    */ import javax.xml.namespace.QName;
/*    */ 
/*    */ 
/*    */ 
/*    */ class AttributePropertyInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>
/*    */   extends SingleTypePropertyInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>
/*    */   implements AttributePropertyInfo<TypeT, ClassDeclT>
/*    */ {
/*    */   private final QName xmlName;
/*    */   private final boolean isRequired;
/*    */   
/*    */   AttributePropertyInfoImpl(ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> parent, PropertySeed<TypeT, ClassDeclT, FieldT, MethodT> seed)
/*    */   {
/* 23 */     super(parent, seed);
/* 24 */     XmlAttribute att = (XmlAttribute)seed.readAnnotation(XmlAttribute.class);
/* 25 */     assert (att != null);
/*    */     
/* 27 */     if (att.required())
/* 28 */       this.isRequired = true; else {
/* 29 */       this.isRequired = nav().isPrimitive(getIndividualType());
/*    */     }
/* 31 */     this.xmlName = calcXmlName(att);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   private QName calcXmlName(XmlAttribute att)
/*    */   {
/* 38 */     String uri = att.namespace();
/* 39 */     String local = att.name();
/*    */     
/*    */ 
/* 42 */     if (local.equals("##default"))
/* 43 */       local = NameConverter.standard.toVariableName(getName());
/* 44 */     if (uri.equals("##default")) {
/* 45 */       XmlSchema xs = (XmlSchema)reader().getPackageAnnotation(XmlSchema.class, this.parent.getClazz(), this);
/*    */       
/*    */ 
/* 48 */       if (xs != null) {
/* 49 */         switch (xs.attributeFormDefault()) {
/*    */         case QUALIFIED: 
/* 51 */           uri = this.parent.getTypeName().getNamespaceURI();
/* 52 */           if (uri.length() == 0) {
/* 53 */             uri = this.parent.builder.defaultNsUri;
/*    */           }
/*    */           break;
/*    */         case UNQUALIFIED: case UNSET: 
/* 57 */           uri = "";
/*    */         }
/*    */       } else {
/* 60 */         uri = "";
/*    */       }
/*    */     }
/* 63 */     return new QName(uri.intern(), local.intern());
/*    */   }
/*    */   
/*    */   public boolean isRequired() {
/* 67 */     return this.isRequired;
/*    */   }
/*    */   
/*    */   public final QName getXmlName() {
/* 71 */     return this.xmlName;
/*    */   }
/*    */   
/*    */   public final PropertyKind kind() {
/* 75 */     return PropertyKind.ATTRIBUTE;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\AttributePropertyInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */