/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.ClassFactory;
/*    */ import com.sun.xml.bind.v2.runtime.Coordinator;
/*    */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class AdaptedAccessor<BeanT, InMemValueT, OnWireValueT>
/*    */   extends Accessor<BeanT, OnWireValueT>
/*    */ {
/*    */   private final Accessor<BeanT, InMemValueT> core;
/*    */   private final Class<? extends XmlAdapter<OnWireValueT, InMemValueT>> adapter;
/*    */   private XmlAdapter<OnWireValueT, InMemValueT> staticAdapter;
/*    */   
/*    */   AdaptedAccessor(Class<OnWireValueT> targetType, Accessor<BeanT, InMemValueT> extThis, Class<? extends XmlAdapter<OnWireValueT, InMemValueT>> adapter)
/*    */   {
/* 21 */     super(targetType);
/* 22 */     this.core = extThis;
/* 23 */     this.adapter = adapter;
/*    */   }
/*    */   
/*    */   public OnWireValueT get(BeanT bean) throws AccessorException {
/* 27 */     InMemValueT v = this.core.get(bean);
/*    */     
/* 29 */     XmlAdapter<OnWireValueT, InMemValueT> a = getAdapter();
/*    */     try {
/* 31 */       return (OnWireValueT)a.marshal(v);
/*    */     } catch (Exception e) {
/* 33 */       throw new AccessorException(e);
/*    */     }
/*    */   }
/*    */   
/*    */   public void set(BeanT bean, OnWireValueT o) throws AccessorException {
/* 38 */     XmlAdapter<OnWireValueT, InMemValueT> a = getAdapter();
/*    */     try {
/* 40 */       this.core.set(bean, a.unmarshal(o));
/*    */     } catch (Exception e) {
/* 42 */       throw new AccessorException(e);
/*    */     }
/*    */   }
/*    */   
/*    */   public Object getUnadapted(BeanT bean) throws AccessorException {
/* 47 */     return this.core.getUnadapted(bean);
/*    */   }
/*    */   
/*    */   public void setUnadapted(BeanT bean, Object value) throws AccessorException {
/* 51 */     this.core.setUnadapted(bean, value);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   private XmlAdapter<OnWireValueT, InMemValueT> getAdapter()
/*    */   {
/* 62 */     Coordinator coordinator = Coordinator._getInstance();
/* 63 */     if (coordinator != null) {
/* 64 */       return coordinator.getAdapter(this.adapter);
/*    */     }
/* 66 */     synchronized (this) {
/* 67 */       if (this.staticAdapter == null)
/* 68 */         this.staticAdapter = ((XmlAdapter)ClassFactory.create(this.adapter));
/*    */     }
/* 70 */     return this.staticAdapter;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\AdaptedAccessor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */