/*     */ package com.sun.xml.txw2.output;
/*     */ 
/*     */ import com.sun.xml.txw2.TxwException;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class StaxSerializer
/*     */   implements XmlSerializer
/*     */ {
/*     */   private final XMLStreamWriter out;
/*     */   
/*     */   public StaxSerializer(XMLStreamWriter writer)
/*     */   {
/*  20 */     this.out = writer;
/*     */   }
/*     */   
/*     */   public void startDocument() {
/*     */     try {
/*  25 */       this.out.writeStartDocument();
/*     */     } catch (XMLStreamException e) {
/*  27 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void beginStartTag(String uri, String localName, String prefix) {
/*     */     try {
/*  33 */       this.out.writeStartElement(prefix, localName, uri);
/*     */     } catch (XMLStreamException e) {
/*  35 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void writeAttribute(String uri, String localName, String prefix, StringBuilder value) {
/*     */     try {
/*  41 */       this.out.writeAttribute(prefix, uri, localName, value.toString());
/*     */     } catch (XMLStreamException e) {
/*  43 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void writeXmlns(String prefix, String uri) {
/*     */     try {
/*  49 */       if (prefix.length() == 0) {
/*  50 */         this.out.setDefaultNamespace(uri);
/*     */       } else {
/*  52 */         this.out.setPrefix(prefix, uri);
/*     */       }
/*     */       
/*     */ 
/*  56 */       this.out.writeNamespace(prefix, uri);
/*     */     } catch (XMLStreamException e) {
/*  58 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void endStartTag(String uri, String localName, String prefix) {}
/*     */   
/*     */   public void endTag()
/*     */   {
/*     */     try
/*     */     {
/*  68 */       this.out.writeEndElement();
/*     */     } catch (XMLStreamException e) {
/*  70 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void text(StringBuilder text) {
/*     */     try {
/*  76 */       this.out.writeCharacters(text.toString());
/*     */     } catch (XMLStreamException e) {
/*  78 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void cdata(StringBuilder text) {
/*     */     try {
/*  84 */       this.out.writeCData(text.toString());
/*     */     } catch (XMLStreamException e) {
/*  86 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void comment(StringBuilder comment) {
/*     */     try {
/*  92 */       this.out.writeComment(comment.toString());
/*     */     } catch (XMLStreamException e) {
/*  94 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void endDocument() {
/*     */     try {
/* 100 */       this.out.writeEndDocument();
/* 101 */       this.out.flush();
/*     */     } catch (XMLStreamException e) {
/* 103 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void flush() {
/*     */     try {
/* 109 */       this.out.flush();
/*     */     } catch (XMLStreamException e) {
/* 111 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\output\StaxSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */