/*    */ package net.rubyeye.xmemcached.command.kestrel;
/*    */ 
/*    */ import java.util.Collection;
/*    */ import java.util.Iterator;
/*    */ import java.util.Map;
/*    */ import java.util.concurrent.CountDownLatch;
/*    */ import net.rubyeye.xmemcached.command.CommandType;
/*    */ import net.rubyeye.xmemcached.command.text.TextGetCommand;
/*    */ import net.rubyeye.xmemcached.transcoders.CachedData;
/*    */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*    */ import net.rubyeye.xmemcached.transcoders.TranscoderUtils;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class KestrelGetCommand
/*    */   extends TextGetCommand
/*    */ {
/*    */   public KestrelGetCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, Transcoder<?> transcoder)
/*    */   {
/* 41 */     super(key, keyBytes, cmdType, latch);
/* 42 */     this.transcoder = transcoder;
/*    */   }
/*    */   
/* 45 */   public static final TranscoderUtils transcoderUtils = new TranscoderUtils(false);
/*    */   
/*    */ 
/*    */   public void dispatch()
/*    */   {
/* 50 */     if (this.returnValues.size() == 0) {
/* 51 */       if (!this.wasFirst) {
/* 52 */         decodeError();
/*    */       } else {
/* 54 */         countDownLatch();
/*    */       }
/*    */     } else {
/* 57 */       CachedData value = (CachedData)this.returnValues.values().iterator().next();
/*    */       
/*    */ 
/* 60 */       if (!this.transcoder.isPrimitiveAsString()) {
/* 61 */         byte[] data = value.getData();
/* 62 */         if (data.length >= 4) {
/* 63 */           byte[] flagBytes = new byte[4];
/* 64 */           System.arraycopy(data, 0, flagBytes, 0, 4);
/* 65 */           byte[] realData = new byte[data.length - 4];
/* 66 */           System.arraycopy(data, 4, realData, 0, data.length - 4);
/* 67 */           int flag = transcoderUtils.decodeInt(flagBytes);
/* 68 */           value.setFlag(flag);
/* 69 */           value.setData(realData);
/* 70 */           value.setCapacity(realData.length);
/*    */         }
/*    */       }
/* 73 */       setResult(value);
/* 74 */       countDownLatch();
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\kestrel\KestrelGetCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */