/*    */ package net.rubyeye.xmemcached.command.text;
/*    */ 
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.concurrent.CountDownLatch;
/*    */ import net.rubyeye.xmemcached.command.CommandType;
/*    */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*    */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*    */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TextCASCommand
/*    */   extends TextStoreCommand
/*    */ {
/*    */   private FailStatus failStatus;
/*    */   
/*    */   public TextCASCommand(String key, byte[] keyBytes, CommandType cmdType, CountDownLatch latch, int exp, long cas, Object value, boolean noreply, Transcoder transcoder)
/*    */   {
/* 45 */     super(key, keyBytes, cmdType, latch, exp, cas, value, noreply, transcoder);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   static enum FailStatus
/*    */   {
/* 52 */     NOT_FOUND,  EXISTS;
/*    */     
/*    */     private FailStatus() {}
/*    */   }
/*    */   
/*    */   public final boolean decode(MemcachedTCPSession session, ByteBuffer buffer) {
/* 58 */     if ((buffer == null) || (!buffer.hasRemaining()))
/* 59 */       return false;
/* 60 */     if (this.result == null) {
/* 61 */       if (buffer.remaining() < 2)
/* 62 */         return false;
/* 63 */       byte first = buffer.get(buffer.position());
/* 64 */       byte second = buffer.get(buffer.position() + 1);
/* 65 */       if ((first == 83) && (second == 84)) {
/* 66 */         setResult(Boolean.TRUE);
/* 67 */         countDownLatch();
/*    */         
/* 69 */         return ByteUtils.stepBuffer(buffer, 8); }
/* 70 */       if (first == 78) {
/* 71 */         setResult(Boolean.FALSE);
/* 72 */         countDownLatch();
/* 73 */         this.failStatus = FailStatus.NOT_FOUND;
/*    */         
/* 75 */         return ByteUtils.stepBuffer(buffer, 11); }
/* 76 */       if ((first == 69) && (second == 88)) {
/* 77 */         setResult(Boolean.FALSE);
/* 78 */         countDownLatch();
/* 79 */         this.failStatus = FailStatus.EXISTS;
/*    */         
/* 81 */         return ByteUtils.stepBuffer(buffer, 8);
/*    */       }
/* 83 */       return decodeError(session, buffer);
/*    */     }
/* 85 */     Boolean result = (Boolean)this.result;
/* 86 */     if (result.booleanValue()) {
/* 87 */       return ByteUtils.stepBuffer(buffer, 8);
/*    */     }
/* 89 */     switch (this.failStatus) {
/*    */     case NOT_FOUND: 
/* 91 */       return ByteUtils.stepBuffer(buffer, 11);
/*    */     case EXISTS: 
/* 93 */       return ByteUtils.stepBuffer(buffer, 8);
/*    */     }
/* 95 */     return decodeError(session, buffer);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextCASCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */