/*     */ package org.codehaus.jackson.map;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.util.Calendar;
/*     */ import java.util.Date;
/*     */ import org.codehaus.jackson.Base64Variant;
/*     */ import org.codehaus.jackson.JsonParser;
/*     */ import org.codehaus.jackson.JsonProcessingException;
/*     */ import org.codehaus.jackson.JsonToken;
/*     */ import org.codehaus.jackson.map.util.ArrayBuilders;
/*     */ import org.codehaus.jackson.map.util.ObjectBuffer;
/*     */ import org.codehaus.jackson.node.JsonNodeFactory;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class DeserializationContext
/*     */ {
/*     */   protected final DeserializationConfig _config;
/*     */   protected final int _featureFlags;
/*     */   
/*     */   protected DeserializationContext(DeserializationConfig config)
/*     */   {
/*  33 */     this._config = config;
/*  34 */     this._featureFlags = config._featureFlags;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public DeserializationConfig getConfig()
/*     */   {
/*  47 */     return this._config;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public DeserializerProvider getDeserializerProvider()
/*     */   {
/*  57 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isEnabled(DeserializationConfig.Feature feat)
/*     */   {
/*  68 */     return (this._featureFlags & feat.getMask()) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Base64Variant getBase64Variant()
/*     */   {
/*  80 */     return this._config.getBase64Variant();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public abstract JsonParser getParser();
/*     */   
/*     */ 
/*     */   public final JsonNodeFactory getNodeFactory()
/*     */   {
/*  90 */     return this._config.getNodeFactory();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType constructType(Class<?> cls)
/*     */   {
/*  97 */     return this._config.constructType(cls);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract ObjectBuffer leaseObjectBuffer();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void returnObjectBuffer(ObjectBuffer paramObjectBuffer);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract ArrayBuilders getArrayBuilders();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract Date parseDate(String paramString)
/*     */     throws IllegalArgumentException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract Calendar constructCalendar(Date paramDate);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract boolean handleUnknownProperty(JsonParser paramJsonParser, JsonDeserializer<?> paramJsonDeserializer, Object paramObject, String paramString)
/*     */     throws IOException, JsonProcessingException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract JsonMappingException mappingException(Class<?> paramClass);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JsonMappingException mappingException(String message)
/*     */   {
/* 184 */     return JsonMappingException.from(getParser(), message);
/*     */   }
/*     */   
/*     */   public abstract JsonMappingException instantiationException(Class<?> paramClass, Throwable paramThrowable);
/*     */   
/*     */   public abstract JsonMappingException instantiationException(Class<?> paramClass, String paramString);
/*     */   
/*     */   public abstract JsonMappingException weirdStringException(Class<?> paramClass, String paramString);
/*     */   
/*     */   public abstract JsonMappingException weirdNumberException(Class<?> paramClass, String paramString);
/*     */   
/*     */   public abstract JsonMappingException weirdKeyException(Class<?> paramClass, String paramString1, String paramString2);
/*     */   
/*     */   public abstract JsonMappingException wrongTokenException(JsonParser paramJsonParser, JsonToken paramJsonToken, String paramString);
/*     */   
/*     */   public abstract JsonMappingException unknownFieldException(Object paramObject, String paramString);
/*     */   
/*     */   public abstract JsonMappingException unknownTypeException(JavaType paramJavaType, String paramString);
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\DeserializationContext.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */