/*    */ package org.codehaus.jackson.map.deser;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.util.EnumSet;
/*    */ import org.codehaus.jackson.JsonParser;
/*    */ import org.codehaus.jackson.JsonProcessingException;
/*    */ import org.codehaus.jackson.JsonToken;
/*    */ import org.codehaus.jackson.map.DeserializationContext;
/*    */ import org.codehaus.jackson.map.JsonDeserializer;
/*    */ import org.codehaus.jackson.map.TypeDeserializer;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class EnumSetDeserializer
/*    */   extends StdDeserializer<EnumSet<?>>
/*    */ {
/*    */   protected final Class<Enum> _enumClass;
/*    */   protected final JsonDeserializer<Enum<?>> _enumDeserializer;
/*    */   
/*    */   public EnumSetDeserializer(EnumResolver enumRes)
/*    */   {
/* 31 */     this(enumRes.getEnumClass(), new EnumDeserializer(enumRes));
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public EnumSetDeserializer(Class<?> enumClass, JsonDeserializer<?> deser)
/*    */   {
/* 38 */     super(EnumSet.class);
/* 39 */     this._enumClass = enumClass;
/* 40 */     this._enumDeserializer = deser;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public EnumSet<?> deserialize(JsonParser jp, DeserializationContext ctxt)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 49 */     if (!jp.isExpectedStartArrayToken()) {
/* 50 */       throw ctxt.mappingException(EnumSet.class);
/*    */     }
/* 52 */     EnumSet result = constructSet();
/*    */     
/*    */     JsonToken t;
/* 55 */     while ((t = jp.nextToken()) != JsonToken.END_ARRAY)
/*    */     {
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 61 */       if (t == JsonToken.VALUE_NULL) {
/* 62 */         throw ctxt.mappingException(this._enumClass);
/*    */       }
/* 64 */       Enum<?> value = (Enum)this._enumDeserializer.deserialize(jp, ctxt);
/* 65 */       result.add(value);
/*    */     }
/* 67 */     return result;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public Object deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 75 */     return typeDeserializer.deserializeTypedFromArray(jp, ctxt);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   private EnumSet constructSet()
/*    */   {
/* 82 */     return EnumSet.noneOf(this._enumClass);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\deser\EnumSetDeserializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */