/*    */ package org.codehaus.jackson.map.ext;
/*    */ 
/*    */ import java.io.StringReader;
/*    */ import javax.xml.parsers.DocumentBuilder;
/*    */ import javax.xml.parsers.DocumentBuilderFactory;
/*    */ import org.codehaus.jackson.map.DeserializationContext;
/*    */ import org.codehaus.jackson.map.deser.FromStringDeserializer;
/*    */ import org.w3c.dom.Document;
/*    */ import org.w3c.dom.Node;
/*    */ import org.xml.sax.InputSource;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class DOMDeserializer<T>
/*    */   extends FromStringDeserializer<T>
/*    */ {
/* 22 */   static final DocumentBuilderFactory _parserFactory = ;
/*    */   
/* 24 */   static { _parserFactory.setNamespaceAware(true); }
/*    */   
/*    */   protected DOMDeserializer(Class<T> cls) {
/* 27 */     super(cls);
/*    */   }
/*    */   
/*    */   protected final Document parse(String value)
/*    */     throws IllegalArgumentException
/*    */   {
/*    */     try
/*    */     {
/* 35 */       return _parserFactory.newDocumentBuilder().parse(new InputSource(new StringReader(value)));
/*    */     } catch (Exception e) {
/* 37 */       throw new IllegalArgumentException("Failed to parse JSON String as XML: " + e.getMessage(), e);
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */   public abstract T _deserialize(String paramString, DeserializationContext paramDeserializationContext);
/*    */   
/*    */   public static class NodeDeserializer
/*    */     extends DOMDeserializer<Node>
/*    */   {
/*    */     public NodeDeserializer()
/*    */     {
/* 49 */       super();
/*    */     }
/*    */     
/* 52 */     public Node _deserialize(String value, DeserializationContext ctxt) throws IllegalArgumentException { return parse(value); }
/*    */   }
/*    */   
/*    */   public static class DocumentDeserializer extends DOMDeserializer<Document>
/*    */   {
/*    */     public DocumentDeserializer() {
/* 58 */       super();
/*    */     }
/*    */     
/* 61 */     public Document _deserialize(String value, DeserializationContext ctxt) throws IllegalArgumentException { return parse(value); }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\ext\DOMDeserializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */