/*     */ package org.codehaus.jackson.map.introspect;
/*     */ 
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.lang.reflect.AnnotatedElement;
/*     */ import java.lang.reflect.Member;
/*     */ import java.lang.reflect.Type;
/*     */ import org.codehaus.jackson.map.type.TypeFactory;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class AnnotatedParameter
/*     */   extends AnnotatedMember
/*     */ {
/*     */   protected final AnnotatedMember _owner;
/*     */   protected final Type _type;
/*     */   protected final AnnotationMap _annotations;
/*     */   
/*     */   public AnnotatedParameter(AnnotatedMember owner, Type type, AnnotationMap ann)
/*     */   {
/*  47 */     this._owner = owner;
/*  48 */     this._type = type;
/*  49 */     this._annotations = ann;
/*     */   }
/*     */   
/*     */   public void addOrOverride(Annotation a)
/*     */   {
/*  54 */     this._annotations.add(a);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public AnnotatedElement getAnnotated()
/*     */   {
/*  68 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public int getModifiers()
/*     */   {
/*  75 */     return this._owner.getModifiers();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String getName()
/*     */   {
/*  82 */     return "";
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <A extends Annotation> A getAnnotation(Class<A> acls)
/*     */   {
/*  91 */     return this._annotations.get(acls);
/*     */   }
/*     */   
/*     */   public Type getGenericType()
/*     */   {
/*  96 */     return this._type;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?> getRawType()
/*     */   {
/* 102 */     if ((this._type instanceof Class)) {
/* 103 */       return (Class)this._type;
/*     */     }
/*     */     
/* 106 */     JavaType t = TypeFactory.defaultInstance().constructType(this._type);
/* 107 */     return t.getRawClass();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> getDeclaringClass()
/*     */   {
/* 118 */     return this._owner.getDeclaringClass();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Member getMember()
/*     */   {
/* 126 */     return this._owner.getMember();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Type getParameterType()
/*     */   {
/* 135 */     return this._type;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\introspect\AnnotatedParameter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */