/*     */ package org.codehaus.jackson.node;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.math.BigDecimal;
/*     */ import java.math.BigInteger;
/*     */ import org.codehaus.jackson.JsonGenerator;
/*     */ import org.codehaus.jackson.JsonParser.NumberType;
/*     */ import org.codehaus.jackson.JsonProcessingException;
/*     */ import org.codehaus.jackson.JsonToken;
/*     */ import org.codehaus.jackson.io.NumberOutput;
/*     */ import org.codehaus.jackson.map.SerializerProvider;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class DoubleNode
/*     */   extends NumericNode
/*     */ {
/*     */   protected final double _value;
/*     */   
/*  26 */   public DoubleNode(double v) { this._value = v; }
/*     */   
/*  28 */   public static DoubleNode valueOf(double v) { return new DoubleNode(v); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JsonToken asToken()
/*     */   {
/*  36 */     return JsonToken.VALUE_NUMBER_FLOAT;
/*     */   }
/*     */   
/*  39 */   public JsonParser.NumberType getNumberType() { return JsonParser.NumberType.DOUBLE; }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isFloatingPointNumber()
/*     */   {
/*  48 */     return true;
/*     */   }
/*     */   
/*  51 */   public boolean isDouble() { return true; }
/*     */   
/*     */   public Number getNumberValue()
/*     */   {
/*  55 */     return Double.valueOf(this._value);
/*     */   }
/*     */   
/*     */   public int getIntValue() {
/*  59 */     return (int)this._value;
/*     */   }
/*     */   
/*  62 */   public long getLongValue() { return this._value; }
/*     */   
/*     */   public double getDoubleValue() {
/*  65 */     return this._value;
/*     */   }
/*     */   
/*  68 */   public BigDecimal getDecimalValue() { return BigDecimal.valueOf(this._value); }
/*     */   
/*     */   public BigInteger getBigIntegerValue()
/*     */   {
/*  72 */     return getDecimalValue().toBigInteger();
/*     */   }
/*     */   
/*     */   public String getValueAsText()
/*     */   {
/*  77 */     return NumberOutput.toString(this._value);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void serialize(JsonGenerator jg, SerializerProvider provider)
/*     */     throws IOException, JsonProcessingException
/*     */   {
/*  84 */     jg.writeNumber(this._value);
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean equals(Object o)
/*     */   {
/*  90 */     if (o == this) return true;
/*  91 */     if (o == null) return false;
/*  92 */     if (o.getClass() != getClass()) {
/*  93 */       return false;
/*     */     }
/*  95 */     return ((DoubleNode)o)._value == this._value;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public int hashCode()
/*     */   {
/* 102 */     long l = Double.doubleToLongBits(this._value);
/* 103 */     return (int)l ^ (int)(l >> 32);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\node\DoubleNode.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */