package prefuse.action.layout;

import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import prefuse.Visualization;
import prefuse.data.Node;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.VisualItem;

public class GridLayout
  extends Layout
{
  protected int rows;
  protected int cols;
  protected boolean analyze = false;
  
  public GridLayout(String paramString)
  {
    super(paramString);
    this.analyze = true;
  }
  
  public GridLayout(String paramString, int paramInt1, int paramInt2)
  {
    super(paramString);
    this.rows = paramInt1;
    this.cols = paramInt2;
    this.analyze = false;
  }
  
  public void run(double paramDouble)
  {
    Rectangle2D localRectangle2D = getLayoutBounds();
    double d1 = localRectangle2D.getMinX();
    double d2 = localRectangle2D.getMinY();
    double d3 = localRectangle2D.getWidth();
    double d4 = localRectangle2D.getHeight();
    TupleSet localTupleSet = this.m_vis.getGroup(this.m_group);
    int i = this.rows;
    int j = this.cols;
    if (this.analyze)
    {
      localObject = analyzeGraphGrid(localTupleSet);
      i = localObject[0];
      j = localObject[1];
    }
    Object localObject = localTupleSet.tuples();
    for (int k = 0; (((Iterator)localObject).hasNext()) && (k < i * j); k++)
    {
      VisualItem localVisualItem2 = (VisualItem)((Iterator)localObject).next();
      localVisualItem2.setVisible(true);
      double d5 = d1 + d3 * (k % j / (j - 1));
      double d6 = d2 + d4 * (k / j / (i - 1));
      setX(localVisualItem2, null, d5);
      setY(localVisualItem2, null, d6);
    }
    while (((Iterator)localObject).hasNext())
    {
      VisualItem localVisualItem1 = (VisualItem)((Iterator)localObject).next();
      localVisualItem1.setVisible(false);
    }
  }
  
  public static int[] analyzeGraphGrid(TupleSet paramTupleSet)
  {
    Iterator localIterator = paramTupleSet.tuples();
    localIterator.next();
    for (int j = 2; localIterator.hasNext(); j++)
    {
      Node localNode = (Node)localIterator.next();
      if (localNode.getDegree() == 2) {
        break;
      }
    }
    int i = paramTupleSet.getTupleCount() / j;
    return new int[] { i, j };
  }
  
  public int getNumCols()
  {
    return this.cols;
  }
  
  public void setNumCols(int paramInt)
  {
    this.cols = paramInt;
  }
  
  public int getNumRows()
  {
    return this.rows;
  }
  
  public void setNumRows(int paramInt)
  {
    this.rows = paramInt;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\layout\GridLayout.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */