package prefuse.data.io;

import java.io.BufferedOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import prefuse.data.Table;
import prefuse.util.collections.IntIterator;

public class DelimitedTextTableWriter
  extends AbstractTableWriter
{
  private String m_delim;
  
  public DelimitedTextTableWriter()
  {
    this("\t");
  }
  
  public DelimitedTextTableWriter(String paramString)
  {
    this.m_delim = paramString;
  }
  
  public void writeTable(Table paramTable, OutputStream paramOutputStream)
    throws DataIOException
  {
    try
    {
      PrintStream localPrintStream = new PrintStream(new BufferedOutputStream(paramOutputStream));
      for (int i = 0; i < paramTable.getColumnCount(); i++)
      {
        if (i > 0) {
          localPrintStream.print(this.m_delim);
        }
        localPrintStream.print(paramTable.getColumnName(i));
      }
      localPrintStream.println();
      IntIterator localIntIterator = paramTable.rows();
      while (localIntIterator.hasNext())
      {
        int j = localIntIterator.nextInt();
        for (int k = 0; k < paramTable.getColumnCount(); k++)
        {
          if (k > 0) {
            localPrintStream.print(this.m_delim);
          }
          Object localObject = paramTable.get(j, paramTable.getColumnName(k));
          localPrintStream.print(localObject == null ? "null" : localObject.toString());
        }
        localPrintStream.println();
      }
      localPrintStream.flush();
    }
    catch (Exception localException)
    {
      throw new DataIOException(localException);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\io\DelimitedTextTableWriter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */