package prefuse.visual.expression;

import java.util.logging.Logger;
import prefuse.data.Tuple;
import prefuse.data.expression.AbstractExpression;
import prefuse.data.expression.Expression;
import prefuse.data.expression.Function;
import prefuse.data.expression.ObjectLiteral;

public abstract class GroupExpression
  extends AbstractExpression
  implements Function
{
  private static final Logger s_logger = Logger.getLogger(GroupExpression.class.getName());
  protected Expression m_group;
  
  protected GroupExpression()
  {
    this.m_group = null;
  }
  
  protected GroupExpression(String paramString)
  {
    this.m_group = new ObjectLiteral(paramString);
  }
  
  protected String getGroup(Tuple paramTuple)
  {
    String str = (String)this.m_group.get(paramTuple);
    if (str == null) {
      s_logger.warning("Null group lookup");
    }
    return str;
  }
  
  public void addParameter(Expression paramExpression)
  {
    if (this.m_group == null) {
      this.m_group = paramExpression;
    } else {
      throw new IllegalStateException("This function takes only 1 parameter.");
    }
  }
  
  public int getParameterCount()
  {
    return 1;
  }
  
  public String toString()
  {
    return getName() + "(" + this.m_group + ")";
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\visual\expression\GroupExpression.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */